--- vlc/modules/gui/macosx/controls.m	Sat Mar 13 16:58:06 2004
+++ vlc-osx/modules/gui/macosx/controls.m	Sat Mar 13 17:28:41 2004
@@ -256,6 +256,37 @@
         vlc_value_t time;
         time.i_time = 10 * 1000000;
         var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump +10 Seconds" ) );
+        vlc_object_release( p_input );
+    }
+}
+
+- (IBAction)forward1Min:(id)sender
+{
+    intf_thread_t * p_intf = [NSApp getIntf];
+    input_thread_t * p_input = vlc_object_find( p_intf, VLC_OBJECT_INPUT,
+                                                       FIND_ANYWHERE );
+    if( p_input != NULL )
+    {
+        vlc_value_t time;
+        time.i_time = 60 * 1000000;
+        var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump +1 Minute" ) );
+        vlc_object_release( p_input );
+    }
+}
+
+- (IBAction)forward5Min:(id)sender
+{
+    intf_thread_t * p_intf = [NSApp getIntf];
+    input_thread_t * p_input = vlc_object_find( p_intf, VLC_OBJECT_INPUT,
+                                                       FIND_ANYWHERE );
+    if( p_input != NULL )
+    {
+        vlc_value_t time;
+        time.i_time = 300 * 1000000;
+        var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump +5 Minutes" ) );
         vlc_object_release( p_input );
     }
 }
@@ -270,7 +301,77 @@
         vlc_value_t time;
         time.i_time = -10 * 1000000;
         var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump -10 Seconds" ) );
         vlc_object_release( p_input );
+    }
+}
+
+- (IBAction)backward1Min:(id)sender
+{
+    intf_thread_t * p_intf = [NSApp getIntf];
+    input_thread_t * p_input = vlc_object_find( p_intf, VLC_OBJECT_INPUT,
+                                                       FIND_ANYWHERE );
+    if( p_input != NULL )
+    {
+        vlc_value_t time;
+        time.i_time = -10 * 1000000;
+        var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump -1 Minute" ) );
+        vlc_object_release( p_input );
+    }
+}
+
+- (IBAction)backward5Min:(id)sender
+{
+    intf_thread_t * p_intf = [NSApp getIntf];
+    input_thread_t * p_input = vlc_object_find( p_intf, VLC_OBJECT_INPUT,
+                                                       FIND_ANYWHERE );
+    if( p_input != NULL )
+    {
+        vlc_value_t time;
+        time.i_time = -300 * 1000000;
+        var_Set( p_input, "time-offset", time );
+        vout_OSDMessage( p_intf, _( "Jump -5 Minutes" ) );
+        vlc_object_release( p_input );
+    }
+}
+
+- (IBAction)position:(id)sender
+{
+    intf_thread_t * p_intf = [NSApp getIntf];
+    playlist_t * p_playlist = vlc_object_find( p_intf, VLC_OBJECT_PLAYLIST,
+                                                       FIND_ANYWHERE );
+    if( p_playlist != NULL)
+    {
+    	input_thread_t * p_input = vlc_object_find( p_intf, VLC_OBJECT_INPUT,
+	                                                        FIND_ANYWHERE );
+		if( p_input != NULL )
+		{
+			char psz_time[MSTRTIME_MAX_SIZE];
+        	vlc_value_t time;
+			mtime_t i_seconds, dur;
+
+        	var_Get( p_input, "time", &time );
+
+			i_seconds = time.i_time / 1000000;
+			secstotimestr(psz_time, (int) i_seconds);
+
+			dur = p_playlist->pp_items[p_playlist->i_index]->i_duration;
+			if( dur != -1 )
+			{
+				char psz_duration[MSTRTIME_MAX_SIZE];
+				char psz_fulltime[MSTRTIME_MAX_SIZE*2];
+				secstotimestr( psz_duration, (int) (dur/1000000) );
+				sprintf ( psz_fulltime, "%s / %s", psz_time, psz_duration);
+				vout_OSDMessage( p_intf, _( psz_fulltime ) );
+			}
+			else if( i_seconds > 0 )
+			{ 
+				vout_OSDMessage( p_intf, _( psz_time ) );
+			}
+        	vlc_object_release( p_input );
+		}
+        vlc_object_release( p_playlist );
     }
 }
 
